/* soapDeviceIOBindingService.h
   Generated by gSOAP 2.8.102 for gen/onvif.h

gSOAP XML Web services tools
Copyright (C) 2000-2020, Robert van Engelen, Genivia Inc. All Rights Reserved.
The soapcpp2 tool and its generated software are released under the GPL.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
--------------------------------------------------------------------------------
A commercial use license is available from Genivia Inc., contact@genivia.com
--------------------------------------------------------------------------------
*/

#ifndef soapDeviceIOBindingService_H
#define soapDeviceIOBindingService_H
#include "soapH.h"

    class SOAP_CMAC DeviceIOBindingService {
      public:
        /// Context to manage service IO and data
        struct soap *soap;
        /// flag indicating that this context is owned by this service and should be deleted by the destructor
        bool soap_own;
        /// Variables globally declared in gen/onvif.h, if any
        /// Construct a service with new managing context
        DeviceIOBindingService();
        /// Copy constructor
        DeviceIOBindingService(const DeviceIOBindingService&);
        /// Construct service given a shared managing context
        DeviceIOBindingService(struct soap*);
        /// Constructor taking input+output mode flags for the new managing context
        DeviceIOBindingService(soap_mode iomode);
        /// Constructor taking input and output mode flags for the new managing context
        DeviceIOBindingService(soap_mode imode, soap_mode omode);
        /// Destructor deletes deserialized data and its managing context, when the context was allocated by the constructor
        virtual ~DeviceIOBindingService();
        /// Delete all deserialized data (with soap_destroy() and soap_end())
        virtual void destroy();
        /// Delete all deserialized data and reset to defaults
        virtual void reset();
        /// Initializer used by constructors
        virtual void DeviceIOBindingService_init(soap_mode imode, soap_mode omode);
        /// Return a copy that has a new managing context with the same engine state
        virtual DeviceIOBindingService *copy() SOAP_PURE_VIRTUAL_COPY;
        /// Copy assignment
        DeviceIOBindingService& operator=(const DeviceIOBindingService&);
        /// Close connection (normally automatic)
        virtual int soap_close_socket();
        /// Force close connection (can kill a thread blocked on IO)
        virtual int soap_force_close_socket();
        /// Return sender-related fault to sender
        virtual int soap_senderfault(const char *string, const char *detailXML);
        /// Return sender-related fault with SOAP 1.2 subcode to sender
        virtual int soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML);
        /// Return receiver-related fault to sender
        virtual int soap_receiverfault(const char *string, const char *detailXML);
        /// Return receiver-related fault with SOAP 1.2 subcode to sender
        virtual int soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML);
        /// Print fault
        virtual void soap_print_fault(FILE*);
    #ifndef WITH_LEAN
    #ifndef WITH_COMPAT
        /// Print fault to stream
        virtual void soap_stream_fault(std::ostream&);
    #endif
        /// Write fault to buffer
        virtual char *soap_sprint_fault(char *buf, size_t len);
    #endif
        /// Disables and removes SOAP Header from message by setting soap->header = NULL
        virtual void soap_noheader();
        /// Add SOAP Header to message
        virtual void soap_header(char *wsa__MessageID, struct wsa__Relationship *wsa__RelatesTo, struct wsa__EndpointReferenceType *wsa__From, struct wsa__EndpointReferenceType *wsa__ReplyTo, struct wsa__EndpointReferenceType *wsa__FaultTo, char *wsa__To, char *wsa__Action, struct wsdd__AppSequenceType *wsdd__AppSequence, struct _wsse__Security *wsse__Security, char *wsa5__MessageID, struct wsa5__RelatesToType *wsa5__RelatesTo, struct wsa5__EndpointReferenceType *wsa5__From, struct wsa5__EndpointReferenceType *wsa5__ReplyTo, struct wsa5__EndpointReferenceType *wsa5__FaultTo, char *wsa5__To, char *wsa5__Action, struct chan__ChannelInstanceType *chan__ChannelInstance);
        /// Get SOAP Header structure (i.e. soap->header, which is NULL when absent)
        virtual ::SOAP_ENV__Header *soap_header();
    #ifndef WITH_NOIO
        /// Run simple single-thread (iterative, non-SSL) service on port until a connection error occurs (returns SOAP_OK or error code), use this->bind_flag = SO_REUSEADDR to rebind for immediate rerun
        virtual int run(int port, int backlog = 1);
    #if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
        /// Run simple single-thread SSL service on port until a connection error occurs (returns SOAP_OK or error code), use this->bind_flag = SO_REUSEADDR to rebind for immediate rerun
        virtual int ssl_run(int port, int backlog = 1);
    #endif
        /// Bind service to port (returns master socket or SOAP_INVALID_SOCKET upon error)
        virtual SOAP_SOCKET bind(const char *host, int port, int backlog);
        /// Accept next request (returns socket or SOAP_INVALID_SOCKET upon error)
        virtual SOAP_SOCKET accept();
    #if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
        /// When SSL is used, after accept() should perform and accept SSL handshake
        virtual int ssl_accept();
    #endif
    #endif
        /// After accept() serve the pending request (returns SOAP_OK or error code)
        virtual int serve();
        /// Used by serve() to dispatch a pending request (returns SOAP_OK or error code)
        virtual int dispatch();
        virtual int dispatch(struct soap *soap);
        //
        // Service operations are listed below: you should define these
        // Note: compile with -DWITH_PURE_VIRTUAL to declare pure virtual methods
        //
        /// Web service operation 'GetServiceCapabilities' implementation, should return SOAP_OK or error code
        virtual int GetServiceCapabilities(_tmd__GetServiceCapabilities *tmd__GetServiceCapabilities, _tmd__GetServiceCapabilitiesResponse *tmd__GetServiceCapabilitiesResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetRelayOutputOptions' implementation, should return SOAP_OK or error code
        virtual int GetRelayOutputOptions(_tmd__GetRelayOutputOptions *tmd__GetRelayOutputOptions, _tmd__GetRelayOutputOptionsResponse *tmd__GetRelayOutputOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioSources' implementation, should return SOAP_OK or error code
        virtual int GetAudioSources(tmd__Get *tmd__GetAudioSources, tmd__GetResponse *tmd__GetAudioSourcesResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioOutputs' implementation, should return SOAP_OK or error code
        virtual int GetAudioOutputs(tmd__Get *tmd__GetAudioOutputs, tmd__GetResponse *tmd__GetAudioOutputsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoSources' implementation, should return SOAP_OK or error code
        virtual int GetVideoSources(tmd__Get *tmd__GetVideoSources, tmd__GetResponse *tmd__GetVideoSourcesResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoOutputs' implementation, should return SOAP_OK or error code
        virtual int GetVideoOutputs(_tmd__GetVideoOutputs *tmd__GetVideoOutputs, _tmd__GetVideoOutputsResponse *tmd__GetVideoOutputsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoSourceConfiguration' implementation, should return SOAP_OK or error code
        virtual int GetVideoSourceConfiguration(_tmd__GetVideoSourceConfiguration *tmd__GetVideoSourceConfiguration, _tmd__GetVideoSourceConfigurationResponse *tmd__GetVideoSourceConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoOutputConfiguration' implementation, should return SOAP_OK or error code
        virtual int GetVideoOutputConfiguration(_tmd__GetVideoOutputConfiguration *tmd__GetVideoOutputConfiguration, _tmd__GetVideoOutputConfigurationResponse *tmd__GetVideoOutputConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioSourceConfiguration' implementation, should return SOAP_OK or error code
        virtual int GetAudioSourceConfiguration(_tmd__GetAudioSourceConfiguration *tmd__GetAudioSourceConfiguration, _tmd__GetAudioSourceConfigurationResponse *tmd__GetAudioSourceConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioOutputConfiguration' implementation, should return SOAP_OK or error code
        virtual int GetAudioOutputConfiguration(_tmd__GetAudioOutputConfiguration *tmd__GetAudioOutputConfiguration, _tmd__GetAudioOutputConfigurationResponse *tmd__GetAudioOutputConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetVideoSourceConfiguration' implementation, should return SOAP_OK or error code
        virtual int SetVideoSourceConfiguration(_tmd__SetVideoSourceConfiguration *tmd__SetVideoSourceConfiguration, _tmd__SetVideoSourceConfigurationResponse *tmd__SetVideoSourceConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetVideoOutputConfiguration' implementation, should return SOAP_OK or error code
        virtual int SetVideoOutputConfiguration(_tmd__SetVideoOutputConfiguration *tmd__SetVideoOutputConfiguration, _tmd__SetVideoOutputConfigurationResponse *tmd__SetVideoOutputConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetAudioSourceConfiguration' implementation, should return SOAP_OK or error code
        virtual int SetAudioSourceConfiguration(_tmd__SetAudioSourceConfiguration *tmd__SetAudioSourceConfiguration, _tmd__SetAudioSourceConfigurationResponse *tmd__SetAudioSourceConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetAudioOutputConfiguration' implementation, should return SOAP_OK or error code
        virtual int SetAudioOutputConfiguration(_tmd__SetAudioOutputConfiguration *tmd__SetAudioOutputConfiguration, _tmd__SetAudioOutputConfigurationResponse *tmd__SetAudioOutputConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoSourceConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetVideoSourceConfigurationOptions(_tmd__GetVideoSourceConfigurationOptions *tmd__GetVideoSourceConfigurationOptions, _tmd__GetVideoSourceConfigurationOptionsResponse *tmd__GetVideoSourceConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetVideoOutputConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetVideoOutputConfigurationOptions(_tmd__GetVideoOutputConfigurationOptions *tmd__GetVideoOutputConfigurationOptions, _tmd__GetVideoOutputConfigurationOptionsResponse *tmd__GetVideoOutputConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioSourceConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetAudioSourceConfigurationOptions(_tmd__GetAudioSourceConfigurationOptions *tmd__GetAudioSourceConfigurationOptions, _tmd__GetAudioSourceConfigurationOptionsResponse *tmd__GetAudioSourceConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetAudioOutputConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetAudioOutputConfigurationOptions(_tmd__GetAudioOutputConfigurationOptions *tmd__GetAudioOutputConfigurationOptions, _tmd__GetAudioOutputConfigurationOptionsResponse *tmd__GetAudioOutputConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetRelayOutputs' implementation, should return SOAP_OK or error code
        virtual int GetRelayOutputs(_tds__GetRelayOutputs *tds__GetRelayOutputs, _tds__GetRelayOutputsResponse *tds__GetRelayOutputsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetRelayOutputSettings' implementation, should return SOAP_OK or error code
        virtual int SetRelayOutputSettings(_tmd__SetRelayOutputSettings *tmd__SetRelayOutputSettings, _tmd__SetRelayOutputSettingsResponse *tmd__SetRelayOutputSettingsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetRelayOutputState' implementation, should return SOAP_OK or error code
        virtual int SetRelayOutputState(_tds__SetRelayOutputState *tds__SetRelayOutputState, _tds__SetRelayOutputStateResponse *tds__SetRelayOutputStateResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetDigitalInputs' implementation, should return SOAP_OK or error code
        virtual int GetDigitalInputs(_tmd__GetDigitalInputs *tmd__GetDigitalInputs, _tmd__GetDigitalInputsResponse *tmd__GetDigitalInputsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetDigitalInputConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetDigitalInputConfigurationOptions(_tmd__GetDigitalInputConfigurationOptions *tmd__GetDigitalInputConfigurationOptions, _tmd__GetDigitalInputConfigurationOptionsResponse *tmd__GetDigitalInputConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetDigitalInputConfigurations' implementation, should return SOAP_OK or error code
        virtual int SetDigitalInputConfigurations(_tmd__SetDigitalInputConfigurations *tmd__SetDigitalInputConfigurations, _tmd__SetDigitalInputConfigurationsResponse *tmd__SetDigitalInputConfigurationsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetSerialPorts' implementation, should return SOAP_OK or error code
        virtual int GetSerialPorts(_tmd__GetSerialPorts *tmd__GetSerialPorts, _tmd__GetSerialPortsResponse *tmd__GetSerialPortsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetSerialPortConfiguration' implementation, should return SOAP_OK or error code
        virtual int GetSerialPortConfiguration(_tmd__GetSerialPortConfiguration *tmd__GetSerialPortConfiguration, _tmd__GetSerialPortConfigurationResponse *tmd__GetSerialPortConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SetSerialPortConfiguration' implementation, should return SOAP_OK or error code
        virtual int SetSerialPortConfiguration(_tmd__SetSerialPortConfiguration *tmd__SetSerialPortConfiguration, _tmd__SetSerialPortConfigurationResponse *tmd__SetSerialPortConfigurationResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'GetSerialPortConfigurationOptions' implementation, should return SOAP_OK or error code
        virtual int GetSerialPortConfigurationOptions(_tmd__GetSerialPortConfigurationOptions *tmd__GetSerialPortConfigurationOptions, _tmd__GetSerialPortConfigurationOptionsResponse *tmd__GetSerialPortConfigurationOptionsResponse) SOAP_PURE_VIRTUAL;
        //
        /// Web service operation 'SendReceiveSerialCommand' implementation, should return SOAP_OK or error code
        virtual int SendReceiveSerialCommand(_tmd__SendReceiveSerialCommand *tmd__SendReceiveSerialCommand, _tmd__SendReceiveSerialCommandResponse *tmd__SendReceiveSerialCommandResponse) SOAP_PURE_VIRTUAL;
    };
#endif
